/// <reference types="node" />
import * as nodeFS from 'fs';
export declare class Authenticator {
    private readonly username;
    private readonly password;
    private readonly permissions;
    private readonly cwd;
    private readonly fs;
    /**
     * @param {string} username
     * @param {string} password
     * @param {string[]} permissions
     *  See https://developer.chrome.com/extensions/declare_permissions
     */
    static for(username: string, password: string, permissions?: string[]): Authenticator;
    asBase64(): string;
    asFileAt(relativePathToExtensionFile: string, mode?: number): string;
    asDirectoryAt(relativePathToDestinationDirectory: string, mode?: number): string;
    constructor(username: string, password: string, permissions: string[], cwd?: string, fs?: typeof nodeFS);
    private extensionFile;
    private authenticatorManifest;
    private authenticatorScript;
    private contentsOf;
}
